#include "perf01_api.h"
#include "perf01_dbd.h"

using namespace RDM_CPP;

Db_perf01 Db_perf01::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "perf01", mode, &perf01_dbd, sizeof(perf01_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_perf01 Db_perf01::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"perf01", mode, &perf01_dbd, sizeof(perf01_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_perf01 Db_perf01::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &perf01_dbd, sizeof(perf01_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_perf01 Db_perf01::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &perf01_dbd, sizeof(perf01_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_perf01::Type (void) {
    char static type;
    return &type;
}

Db_perf01::Db_perf01 (void) throw () {
}

Db_perf01::Db_perf01 (const Db& db) throw () : Db (db, Type()) {
}

Db_perf01::Db_perf01 (const Db_perf01& db) throw () : Db (db) {
}

Db_perf01::Db_perf01 (IDb *idb) : Db (idb) {
}

Db_perf01& Db_perf01::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_perf01& Db_perf01::operator = (const Db_perf01& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_perf01::~Db_perf01 () {
}

Cursor_simple Db_perf01::New_simple_record (void) const throw (rdm_exception&) {
    return Cursor_simple (NewRecords (Cursor_simple::Type ()));
}

Cursor_simple Db_perf01::New_simple_recordWithFieldValues (struct simple *fields) const throw (rdm_exception&) {
    return Cursor_simple (NewRecordsWithFieldValues (Cursor_simple::Type (), fields));
}

Cursor_simple Db_perf01::Get_simple_records (void) const throw (rdm_exception&) {
    return Cursor_simple (GetRecords (Cursor_simple::Type ()));
}

recordType Cursor_simple::Type (void) {
    return SIMPLE;
}

Cursor_simple::Cursor_simple (void) throw () {
}

Cursor_simple::Cursor_simple (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_simple::Cursor_simple (const Cursor_simple& cursor) throw () : Cursor (cursor) {
}

Cursor_simple& Cursor_simple::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_simple& Cursor_simple::operator = (const Cursor_simple& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

void Cursor_simple::SetFieldValues (const struct simple *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_simple::GetFieldValues (struct simple *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_simple::Set_int_col (int32_t int_col_val) const throw (rdm_exception&) {
    SetField (SIMPLE_INT_COL, &int_col_val);
}

void Cursor_simple::Get_int_col (int32_t *int_col_val) const throw (rdm_exception&) {
    GetField (SIMPLE_INT_COL, int_col_val);
}

void Cursor_simple::Set_sysnulls_ (const char sysnulls__val[1][1]) const throw (rdm_exception&) {
    SetField (SIMPLE_SYSNULLS_, sysnulls__val);
}

void Cursor_simple::Get_sysnulls_ (char sysnulls__val[1][1]) const throw (rdm_exception&) {
    GetField (SIMPLE_SYSNULLS_, sysnulls__val);
}

Cursor_simple::~Cursor_simple () {
}

